local _, L = ...
local mediaFolder = "Interface\\AddOns\\".._.."\\Media\\"
local LMB, RMB = CreateAtlasMarkup("NPE_LeftClick", 18, 18), CreateAtlasMarkup("NPE_RightClick", 18,18)
local LCG = LibStub('LibCustomGlow-2.0')

local C_Timer_After = C_Timer.After

motsPanelMixin = {}

local tabulka = {	[1] = { true,	false, 	true,	false,	3515222},
					[2] = { true, 	true, 	true,	false,	3515223},
					[3] = { false, 	false, 	true,	false,	3515224},
					[4] = { false, 	true, 	true,	false,	3515225},
					[5] = { true, 	false, 	false,	false,	3515222},
					[6] = { true, 	true, 	false,	false,	3515223},
					[7] = { false, 	false, 	false,	false,	3515224},
					[8] = { false, 	true, 	false,	false,	3515225},
				}

function motsPanelMixin:CreateMotsPanel()
	local backdrop = {bgFile = "Interface\\Buttons\\WHITE8x8", edgeFile = "Interface\\Buttons\\WHITE8x8", tile = false, tileSize = 1, edgeSize = 1, insets = { left = 1, right = 1, top = 1, bottom = 1 }}
	local buttonSize = 42
	local toggleSize = 7
	local frameAlpha = 0.8
	
	motsPanel:SetPoint("TOP", UIParent, "TOP", 0, 1)
	motsPanel:SetAlpha(frameAlpha)
	motsPanel:SetBackdrop(backdrop)
	motsPanel:SetBackdropColor(0, 0, 0, frameAlpha)
	motsPanel:SetBackdropBorderColor(1, 0, 0)
	motsPanel:SetSize((buttonSize * 4) + 21, toggleSize + 2)
	motsPanel.button = {}
	motsPanel:Hide()
	
	function motsPanel:CreateMotsButton(i, size)
		local button = CreateFrame("Button", "Button"..i, self, "SecureActionButtonTemplate")
			button:SetSize(size, size)
			
			button:SetNormalTexture(mediaFolder.."mots\\"..i)
			button:SetPushedTexture(mediaFolder.."mots\\"..i)
			button:SetHighlightTexture(mediaFolder.."mots\\"..i, "ADD")			
						
			button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
			button:Show()
			
		return button
	end

	function motsPanel:ResetAllButtons()
		for i = 1, #motsPanel.button do
			tabulka[i][4] = false
			LCG.AutoCastGlow_Stop(motsPanel.button[i])
		end
	end
	
	function motsPanel:UpdateMotsPanel()
		for i = 1, #motsPanel.button do
			if not tabulka[i][4] then
				LCG.AutoCastGlow_Stop(button)
			end
				
			motsPanel.button[i]:Show()
		end
	end

	function motsPanel:test(index, f)
		for i = 1, #motsPanel.button do
			if tabulka[i][4] then
				if tabulka[i][index] == f then
					return i
				end
			end
		end
		return 0
	end
	
	function motsPanel:ClickedButton(clicked)
		local pushed = 0
				
		for i = 1, #motsPanel.button do
			if tabulka[i][4] then
				pushed = pushed + 1
			end
		end
		
		if pushed < 3 or tabulka[clicked][4] then
			if tabulka[clicked][4] then
				LCG.AutoCastGlow_Stop(motsPanel.button[clicked])
				tabulka[clicked][4] = false
				-- zmen vsetky na zlte 
				for i = 1, #motsPanel.button do
					if tabulka[i][4] then
						LCG.AutoCastGlow_Start(motsPanel.button[i], {1, 1, 0, 1}, 12, nil, 1, 0, 0)
					end
				end
			else
				LCG.AutoCastGlow_Start(motsPanel.button[clicked], {1, 1, 0, 1}, 12, nil, 1, 0, 0)
				tabulka[clicked][4] = true
			end
		elseif pushed == 3 then
			local flower, leaf, fill, empty, ring, noring = 0, 0, 0, 0, 0, 0
			local searched = 0
			
			tabulka[clicked][4] = true
			
			for i = 1, #motsPanel.button do
				if tabulka[i][4] then
					if tabulka[i][1] then 
						flower = flower + 1
					else
						leaf = leaf + 1
					end
					if tabulka[i][2] then 
						fill = fill  + 1
					else
						empty = empty + 1
					end
					if tabulka[i][3] then 
						ring = ring  + 1
					else
						noring = noring + 1
					end
				end
			end
					
					
			if flower == 1 then
				searched = motsPanel:test(1, true)
			elseif leaf == 1 then
				searched = motsPanel:test(1, false)
			elseif fill == 1 then
				searched = motsPanel:test(2, true)
			elseif empty == 1 then
				searched = motsPanel:test(2, false)
			elseif ring == 1 then
				searched = motsPanel:test(3, true)
			elseif noring == 1 then
				searched = motsPanel:test(3, false)
			end
			
			--print(flower, leaf, fill, empty, ring, noring)
			--print(searched)
			
			
			if searched > 0 then
				if clicked ~= searched then
					LCG.AutoCastGlow_Start(motsPanel.button[clicked], {1, 1, 0, 1}, 12, nil, 1, 0, 0)
				end
				
				LCG.AutoCastGlow_Start(motsPanel.button[searched], {0, 1, 0, 1}, 12, nil, 1, 0, 0)
			else
				tabulka[clicked][4] = false
			end
		end
	end
	
	for i = 1, 8 do
		motsPanel.button[i] = motsPanel.button[i] or motsPanel:CreateMotsButton(i, buttonSize)
		motsPanel.button[i].id = i
			
		motsPanel.button[i]:SetScript("OnClick", function(self, button)
			if button ==  "LeftButton" then
				if IsInGroup() then
					C_ChatInfo.SendAddonMessage("MOTSH", self.id, namePlateMixin:InstanceOrParty())
				else
					motsPanel:ClickedButton(self.id)
				end
			elseif button == "RightButton" then
				if IsInGroup() then
					C_ChatInfo.SendAddonMessage("MOTSH", "reset", namePlateMixin:InstanceOrParty())
				else
					motsPanel:ResetAllButtons()
				end
			end		
		end)
		
		if i == 1 then
			motsPanel.button[i]:SetPoint("BOTTOMLEFT", motsPanel, 4, toggleSize + 2)
		elseif i < 5 then
			motsPanel.button[i]:SetPoint("LEFT", motsPanel.button[i - 1], "RIGHT", 4, 0)
		else
			motsPanel.button[i]:SetPoint("BOTTOM", motsPanel.button[i - 4], "TOP", 0, 2)
		end
		
	end
	
	motsPanel:UpdateMotsPanel()
		
	-- bocna lista
	local toggleButton = CreateFrame("BUTTON", "ToggleButton", motsPanel, "SecureHandlerClickTemplate")
	toggleButton:SetPoint("BOTTOMLEFT", 1, 1)
	toggleButton:SetPoint("BOTTOMRIGHT", -1, 1)
	toggleButton:SetHeight(toggleSize)
	toggleButton:RegisterForClicks("LeftButtonUp")
	
	toggleButton.bg = toggleButton:CreateTexture(nil, "BACKGROUND", nil)
	toggleButton.bg:SetAllPoints()
	toggleButton.bg:SetColorTexture(0, 0, 0)
	toggleButton.bg:SetAlpha(0.4)
	
	toggleButton.tooltipText = LMB.." - open or close motsPanel\n"..RMB.." - move motsPanel to new position"
	toggleButton:SetScript("OnEnter", function(self)
		--GameTooltip:SetOwner(self, "ANCHOR_TOP")
		--GameTooltip:AddLine(self.tooltipText, 0, 1, 0.5, false)
		--GameTooltip:Show()
		toggleButton.bg:SetAlpha(1)
	end)
	toggleButton:SetScript("OnLeave", function(self)
		--GameTooltip:Hide()
		toggleButton.bg:SetAlpha(.4)
	end)
	
	toggleButton:SetAttribute("_onclick", [=[
	local ref = self:GetFrameRef("motsPanel")
	if not ref:GetAttribute("open") then
		ref:SetAttribute("open", false)
	end
	if ref:GetAttribute("open") == false then
		ref:SetHeight(100)
		ref:SetAttribute("open", true)
	else
		ref:SetHeight(7 + 2)
		ref:SetAttribute("open", false)
	end
	]=])
	toggleButton:SetFrameRef("motsPanel", motsPanel)
	
	motsPanel:SetMovable(true)
	toggleButton:EnableMouse(true)
    toggleButton:SetClampedToScreen(true)
    toggleButton:RegisterForDrag("RightButton")
    
	toggleButton:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" and not InCombatLockdown() then
			self:GetParent():SetClampedToScreen(true)
			self:GetParent():StartMoving()
		end
    end)
    
	toggleButton:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and not InCombatLockdown() then
			local cursorX, cursorY = GetCursorPosition()
			self:GetParent():SetClampedToScreen(false)
			self:GetParent():StopMovingOrSizing()
			self:GetParent():ClearAllPoints()
			self:GetParent():SetPoint("TOP", UIParent, "TOPLEFT", cursorX * GetScreenHeightScale(), 1)
		end
    end)
end

function motsPanelMixin:OnEvent(event, ...)
	if ( event == "ADDON_LOADED" ) then
		local name = ...
		if name == _ then
			C_ChatInfo.RegisterAddonMessagePrefix("MOTSH")
			self:CreateMotsPanel()
		end

	elseif ( event == "ZONE_CHANGED_NEW_AREA" ) then
		C_Timer_After(2, function()
			if L.isChallengeMap and L.mapID == 375 then
				motsPanel:UpdateMotsPanel()
				motsPanel:Show()
			elseif motsPanel:IsShown() then
				motsPanel:Hide()
			end
		end)
		
	elseif ( event == "CHAT_MSG_ADDON" ) then
		local prefix, str = ...
		if prefix == "MOTSH" then
			if tonumber(str) then
				motsPanel:ClickedButton(tonumber(str))
			elseif str == "reset" then
				motsPanel:ResetAllButtons()
			end
		end
	end
end

function motsPanelMixin:OnLoad()
	for _, event in pairs({
		"ADDON_LOADED",
		"ZONE_CHANGED_NEW_AREA",
		"CHAT_MSG_ADDON",
	}) do self:RegisterEvent(event) end
end